#!/usr/local/bin/perl
#
# dcpost.cgi
# DCForum99 Version 1.1
# Part of DCForum by DCScripts
# Copyright  1997-1999 DCScripts All Rights Reserved
# 
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum.
# You should carefully read this terms agreement as outlined in
# the readme.txt file included with this distribution before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
###################################################################
##  German translation by Lothar Jung for Webster Internet Dienstleistungen
##  http://Webster.de/dcscripts/
###################################################################

# Geben Sie den genauen Pfad ($path) zu diesem Programm an wenn
# wenn Sie bei der Ausf&uuml;hrung der Datei Probleme haben.

$path = ".";

#>>>>>>>>>>>>>>> Keine weiteren &Auml;nderungen in diesem Script erforderlich <<<<<<<<


require "$path/dcforum.setup";
require "$path/dcboard.setup";
require "$cgidir/cgi-lib.pl";
require "$cgidir/dcforumlib.pl";
require "$cgidir/dcforumlib2.pl";
require "$cgidir/dclib.pl";
require "$cgidir/dcprotect.pl";

$| = 1;

&ReadParse;

if ($in{"preview_option"} ne ""){
	   $in{'type'} = $in{'az'};
	   $in{'az'} = "pview";
	print "Content-type: text/html\n";	   
}
elsif ($in{'az'}) {
	#Do Nothing
	print "Content-type: text/html\n";
}
elsif ($in{"post_option"} ne ""){
	   $in{'az'} = "a_mesg";
	print "Content-type: text/html\n";
} 

unless ($in{'az'} eq 'a_mesg' or $in{'az'} eq 'e_mesg') {

	print "Content-type: text/html\n";
}

$r_in = \%in;

# Other variables you won't have to change

if ($r_in->{'database'} eq "" || $r_in->{'database'} ne 'archive') {
   	$r_in->{'database'} = $database;
}
else {
  $database = "arc_" . $database;
   $r_in->{'arc_database'} = $database;
}

get_date($r_in);

$r_setup = initialize($password_file_dir,$forum_file,$board_setup_file);

# Set Global variables

require "$path/global.pl";

# If the input forum type is Private, then
# set appropriate file extension and dir

if ($r_setup->{'forum_type'}->{ $r_in->{'forum'} } eq 'Private') {
   $ext = $privateext;
   $maindir = $privatedir;
}

# Get forum information and put them in old variables

$forum = $in{'forum'};

$az = $in{'az'};

# OK, before we do anything, let's check the user's cookie
# If session exists, then get user data

$r_in->{'userdata'} = {};
$session = get_cookie($cookie_name);
if ($session) {
	if (-e "$password_file_dir/$session.session") {
		$r_in->{'userdata'} = get_userdata("$password_file_dir/$session.session");
	}
	else {
	   send_cookie($cookie_name,'','Thur, 31-Dec-98 12:00:00 GMT','/');
		$session = '';
	}
}


# If no $session and forum_type if Private or Protected,
# well, then you need to have them logon
unless ($session) {
	if ($r_setup->{'forum_type'}->{$forum} eq 'Private' ||
         $r_setup->{'forum_type'}->{$forum} eq 'Protected') {
      $r_in->{'userdata'} = dcprotect($dcpost,$password_file_dir,$r_in,
         \@login_fields,\%field_form_type);
   }
}
else {
	$r_in->{'email'} = add_antispam($r_in->{'email'});
}


if ($az eq "post") {

   print "\n";

   $html_forum_links = &forum_links($r_in,$r_setup);
   $heading = $heading_post . " in $r_setup->{'forum_name'}->{$forum}";
   $sub_heading = $sub_heading_post;
	$in{'rand1'} = get_rand_lock();
   $html_output .= post($r_in,$r_setup);

}
elsif ($az eq "pview") {

   get_form_variables($r_in,$r_setup);
   display_status("pview",$r_in,$r_setup);

}
elsif ($az eq "a_mesg") {

	my $new_mesg;
  
   get_form_variables($r_in,$r_setup);

   if (check_rand_lock($in{'rand1'})) {

		&filter_remote_posting();
		
      if ($in{'om'} == 0 or $in{'om'} eq "") {
         $in{'om'} = get_number("$maindir/$forum/$datafile",$r_in);
         add_message("$maindir/$forum/$database",$r_in,$r_setup);
         $html_forum_links = &forum_links($r_in,$r_setup);
         create_thread($r_in,$r_setup);
			$new_mesg = 'yes';
      }
      else {
         update_database("$maindir/$forum/$database",$r_in);
         update_thread($r_in,$r_setup);
      }

      create_message($r_in,$r_setup);
   }

   # OK, all the messages are updated...let's send some emails
	 
	if ($r_setup->{'board_setup'}->{'email_notification'} eq 'on') {

		my	$r_local = {};	
 		get_setup_variables("$r_in->{'password_file_dir'}/$r_in->{'auth_setup_file'}",$r_local);		

		unless ($in{'om'} && (-e "$maindir/$forum/$email_dir/$in{'om'}.$email_ext")) {

			my @temp;
			push(@temp,"$r_in->{'subject'}\n");
			if ($r_in->{'email_notification'}) {
					push(@temp,"$r_in->{'email'}\n");
			}

			writedata("$maindir/$forum/$email_dir/$in{'om'}.$email_ext",\@temp);

			my $url;
			unless ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
				$url = "$mainurl/$forum/$in{'om'}.$ext";
			}
			else {
				$url = "$exurl?az=show_thread&om=$in{'om'}&forum=$forum";					
			}

         my $mail_message .= qq~
Im DC Forum $forum wurde ein neuer Beitrag geschrieben:
Thema: "$r_in->{'subject'}"
URL: $url
~;

			if ($r_setup->{'board_setup'}->{'email_to_admin'} eq 'on') {
			   send_mail($password_file_dir, $r_local->{'Sendmail Path'},
		         $r_local->{'Admin EMail Address'},$r_local->{'Admin EMail Address'},
		         $email_notification_subject,$mail_message );
			}
			
			if ($r_setup->{'board_setup'}->{'email_to_mod'} eq 'on') {
				my $moderator_email = $r_setup->{'forum_owner_email'}->{$forum};
				$moderator_email = remove_antispam($moderator_email);
				unless ($moderator_email eq $r_setup->{'board_setup'}->{'email_to_admin'}) {
					if (check_email($moderator_email)) {
				   	send_mail($password_file_dir, $r_local->{'Sendmail Path'},
			         	$r_local->{'Admin EMail Address'},$moderator_email,
		   	      	$email_notification_subject,$mail_message );
					}
				}
			}

		}

		else {

			email_notification($r_in,$r_setup,$r_local);

			if ($r_in->{'email_notification'}) {
				appenddata("$maindir/$forum/$email_dir/$in{'om'}\.$email_ext",$r_in->{'email'});
			}

		}

	}

   # If the message added is a reply, redirect to that thread

   unless ($new_mesg) {
		$r_in->{'indent'} = '';
		$r_in->{'omm'} = $r_in->{'next_file_num'};
      if ($r_setup->{'forum_type'}->{ $forum } eq 'Private') {
			print "Content-type: text/html\n";
         print "\n";
			$heading = "Nachricht eingetragen!";
			$sub_heading = "<b>Nachfolgend Ihr Beitrag</b><br>&nbsp;&nbsp;<br>";
         show_thread($r_in,$r_setup);
      }
      elsif ($r_setup->{'board_setup'}->{'max_messages'} < $r_in->{'omm'}) {
			print "Content-type: text/html\n";
         print "\n";
			$heading = "Nachricht eingetragen!";
			$sub_heading = "<b>Nachfolgend Ihr Beitrag</b><br>&nbsp;&nbsp;<br>";
         show_thread($r_in,$r_setup);
      }
      else {
         print "Location: $mainurl/$forum/$in{'om'}.$ext#$r_in->{'next_file_num'}\n\n";
         exit(0);
      }
   }
	else {
	   print "Location: $boardurl?az=list&forum=$forum\n\n";
		exit(0);
	}

}
elsif ($az eq "edit") {

	unless ($r_in->{'userdata'}->{'Username'}) {
     $r_in->{'userdata'} = dcprotect($dcpost,$password_file_dir,$r_in,
      \@login_fields,\%field_form_type);
	}

   print "\n";

   $heading = "Ihre Nachricht bearbeiten";
   $sub_heading = "<B>Machen Sie Ihre Aenderungen und klicken auf absenden.</B>";
   $html_output .= edit($r_in,$r_setup);

}
elsif ($az eq "e_mesg") {

	my $orig_omm = $in{'omm'};

	unless ($r_in->{'userdata'}->{'Username'}) {
	   unless ($r_setup->{'forum_type'}->{$forum} eq "Public" 
					or $r_in->{'userdata'}->{'Username'}) {

   	   $r_in->{'userdata'} = dcprotect($dcpost,$password_file_dir,$r_in,
      	   \@login_fields,\%field_form_type);

   	}
	   else {

   	   $r_in->{'email'} = add_antispam($r_in->{'email'});

   	}
	}
	
	
	if (check_rand_lock($in{'rand1'})) {
      get_form_variables($r_in,$r_setup);
      edit_message($r_in,$r_setup);
      create_message($r_in,$r_setup);
   }

	$r_in->{'omm'} = $orig_omm;
   if ($r_setup->{'forum_type'}->{ $forum } eq 'Private') {
		print "Content-type: text/html\n";
   	print "\n";
		$r_in->{'indent'} = '';
		$heading = "Aenderung erfolgreich!";
		$sub_heading = "<b>Nachfolgend Ihr Beitrag</b><br>&nbsp;&nbsp;<br>";
   	show_thread($r_in,$r_setup);
   }
   else {
		print "Location: $mainurl/$forum/$in{'om'}.$ext#$r_in->{'omm'}\n\n";
   	exit(0);
   }

}
else {
	$heading = "DCForum99 Bulletin Board System<br>&copy; 1997-1999 <a href=\"http://www.dcscripts.com\">DCScripts</a>";
}

$html_forum_links = forum_links($r_in,$r_setup);

my %namespace = (
     FORUMLINKS => $html_forum_links,
     MENU => $menu_button,
     TITLE => $heading,
     HEADER => $heading,
     SUBHEADER => $sub_heading,
     HTMLOUTPUT => $html_output
);

display_output($templatefile,\%namespace);

exit(0);

####
#
# subroutine add_message
# Adds new thread
####

sub add_message {

   my ($datafile,$r_in,$r_setup) = @_;

   my $num_threads;
   my $temp_time = substr($r_in->{'localtime'},0,5);
   my $last_date = "$temp_time $r_in->{'date'}";

	# Create Captions
   my $caption = $r_in->{'body'};
   $caption =~ s/<([^>]|\n)*>/ /g;
# BIG5
#   $caption =~ s/::/&pip;/g;
   $caption =~ s/\|/&pip;/g;
   $caption = substr($caption,0,$r_setup->{'board_setup'}->{'caption_length'});

	# Prepare message line
# BIG5 
#   my $data_in = join("::",$r_in->{'om'},
#        $r_in->{'date'},$r_in->{'localtime'},
#        $r_in->{'name'},$r_in->{'subject'},$caption,0);
   my $data_in = join("\|",$r_in->{'om'},
        $r_in->{'date'},$r_in->{'localtime'},
        $r_in->{'name'},$r_in->{'subject'},$caption,0);

   my $r_rowdata = readdata($datafile);
  
	# If the number of threads exceed preset max, then prune threads...
	# But make sure $in{'max_threads_allowed'} is defined and not equal to 0

   if ($max_threads_allowed || ($max_threads_allowed > 0) ) {

      $num_threads = @$r_rowdata;
      if ($num_threads >= $max_threads_allowed) {
         @prune_list = @$r_rowdata[$max_threads_allowed-1..$num_threads];
         @$r_rowdata = @$r_rowdata[0..$max_threads_allowed-2];
         foreach (@prune_list) {
# BIG5
#           ($p_num,@dummy) = split(/::/, $_);
           ($p_num,@dummy) = split(/\|/, $_);
           unlink("$maindir/$forum/$p_num\.$ext");
         } 
      }
   }

   # Write back to the database

   unshift(@$r_rowdata,"$data_in\n");
   writedata($datafile,$r_rowdata);
  
   # Now, let's update forum thread total and
   # lasttime it was updated

   $r_setup->{'forum_last'}->{$forum} = $last_date;

   my $forum_dir = $password_file_dir;
   my $forum_file = $forum_file;

   if ($max_threads_allowed > $num_threads) {
      $r_setup->{'forum_threads'}->{$forum} = $num_threads + 1;
   }
   else {
      $r_setup->{'forum_threads'}->{$forum} = $max_threads_allowed;
   }
	     
   save_forum_info("$forum_dir/$forum_file",$r_setup);

}

####
#
# subroutine update_database
#
####

sub update_database {

   my ($datafile,$r_in) = @_;

   my $temp_time = substr($r_in->{'localtime'},0,5);
   my $last_date = "$temp_time $r_in->{'date'}";

   my $r_rowdata = readdata($datafile);

   foreach ($j = 0;$j <= @$r_rowdata;$j++) {
# BIG5
#      if ($r_rowdata->[$j] =~ /^$r_in->{'om'}::/) {
      if ($r_rowdata->[$j] =~ /^$r_in->{'om'}\|/) {
# BIG5
#         my ($num,$origdate,$origtime,
#            $origname,$origsubject,$origcaption,$replies) = split(/::/, $r_rowdata->[$j]);
         my ($num,$origdate,$origtime,
            $origname,$origsubject,$origcaption,$replies) = split(/\|/, $r_rowdata->[$j]);
         $replies ++;
# BIG5
#         $new_data =
#            join("::",$num,$r_in->{'date'},$r_in->{'localtime'},
#              $origname,$origsubject,$origcaption,$replies);
         $new_data =
            join("\|",$num,$r_in->{'date'},$r_in->{'localtime'},
              $origname,$origsubject,$origcaption,$replies);
         splice(@$r_rowdata, $j, 1);
         $j --;
         last;
      }
   }

   unshift(@$r_rowdata, "$new_data\n");
   writedata($datafile,$r_rowdata);

   # Update last modifed date in the forum file
   $r_setup->{'forum_last'}->{$forum} = $last_date;
   save_forum_info("$password_file_dir/$forum_file",$r_setup);

}

####
#
# subroutine thread_message
# Threads a reply message
#
###

sub update_thread {

   my ($r_in,$r_setup) = @_; 
   my (@newrow, $level);
   my $r_rowdata = readdata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext");

	# First get the number of messages and the next message number
	$r_in->{'next_file_num'} = shift @{$r_rowdata};
	chomp($r_in->{'next_file_num'});
   $r_in->{'next_file_num'}++;

   push(@newrow,"$r_in->{'next_file_num'}\n");
	$r_in->{'omm'} = 0 unless($r_in->{'omm'});

	# Now, if reverse_thread is on, then find where we'll
	# thread the message
   if ($r_setup->{'board_setup'}->{'reverse_thread'} eq "on") {

      my $r_message = {};
      my $count = 0;
      my @sublevel;
      my $templevel = 0;

      # Pull off sublevels
      foreach (@{$r_rowdata}) {
      	chomp;
# BIG5
#      	my @temp = split /::/;
      	my @temp = split /\|/;
         $r_message->{$count} = \@temp;
         $count++;
      } #End of foreach  

      foreach ( sort { $a <=> $b } keys %{$r_message} ) {
         if ($r_message->{$_}->[0] == $r_in->{'omm'}) {
            $level = 1 + $r_message->{$_}->[1];
            $templevel = $level;
            push(@sublevel,$_);
         }
         elsif ($templevel) {
            if ($r_message->{$_}->[1] <= $templevel - 1) {
               $templevel = "";
            }
            else {
               push(@sublevel,$_);
            }
         }
      } #End of foreach

      $temp = pop(@sublevel);
      $r_in->{'omm'} = $r_message->{$temp}->[0];

	}

	# At this point, $$r_in->{'omm'} is the message
	# Right before current thread
	# Now, just go thru the data again and thread it correctly
   foreach (@{$r_rowdata}) {
      chomp;
	   push(@newrow,"$_\n");
# BIG5
#		my @temp = split /::/;
		my @temp = split /\|/;
      if ($r_in->{'omm'} eq $temp[0]) {
			$level = $temp[1] + 1 unless ($r_setup->{'board_setup'}->{'reverse_thread'} eq "on");
# BIG5
#         push(@newrow,"$r_in->{'next_file_num'}::$level::$r_in->{'subject'}::$r_in->{'name'}::$r_in->{'email'}::$r_in->{'localtime'}::$r_in->{'date'}::$r_in->{'body'}\n");
         push(@newrow,"$r_in->{'next_file_num'}\|$level\|$r_in->{'subject'}\|$r_in->{'name'}\|$r_in->{'email'}\|$r_in->{'localtime'}\|$r_in->{'date'}\|$r_in->{'body'}\n");
	   }
   }

	# Write to output file
   writedata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",\@newrow);

}

####
#
# subroutine post
# Display Post Page
#
####

sub post {

   my ($r_in,$r_setup) = @_;
	my ($omm,$level,$subject,$name,$email,$ltime,$date,$body);
	my $r_profile;

	if (-e "$password_file_dir/$profile_dir/$r_in->{'userdata'}->{'Username'}.$profile_ext") {
		$r_profile = 
			get_userdata("$password_file_dir/$profile_dir/$r_in->{'userdata'}->{'Username'}.$profile_ext");
		$r_profile->{'Signatur'} = html_cntl($r_profile->{'Signatur'});
	}
		
   if ($r_in->{'om'}) {
	  ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = 
			get_record("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",$r_in->{'omm'});
   }

   my $html_output .= qq~
	<p>
	~;

	if ($r_setup->{'board_setup'}->{'show_orig_mesg'} eq 'on' && $r_in->{'om'}) {

	   $ltime = time_format($ltime);
	   $date = date_format($date);

	   $html_output .= qq~
	   <TABLE CELLPADDING="3" cellspacing="2" BORDER="0" WIDTH="$table_width">
	   <TR BGCOLOR="$bg_color_0">
	   <TH ALIGN="LEFT">
	   <FONT SIZE="3" FACE="$font_face_0" COLOR="$font_color_0">
		Original Beitrag
	   </FONT>
	   </TH>
	   </tr>
	   <TR BGCOLOR="$bg_color_2">
	   <Td ALIGN="LEFT">
	   <FONT SIZE="$font_size_2" FACE="$font_face_2" COLOR="$font_color_2">
	   <b>"$subject"</b><br>
		Geschrieben von $name am $date um $ltime
	   </FONT></Td></tr>
	   <TR BGCOLOR="$bg_color_1">
	   <Td ALIGN="LEFT">
	   <FONT SIZE="$font_size_1" FACE="$font_face_1" COLOR="$font_color_1">
		<blockquote>
		$body
		</blockquote>
	   </FONT>
	   </Td>
	   </tr>
		</table>~;
	}
	
# Sie k&ouml;nnen das auch von Email verwendete RE: Format f&uuml;r Antworten
# verwenden. Sie m&uuml;ssen dazu die folgenden Zeilen auskommentieren
###################################################################
#	($omm,$level,$subject,$name,$email,$ltime,$date,$body) = 
#		get_record("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",$r_in->{'omm'});
#   unless ($r_in->{'quote'}) {
#		$omm = 0;
#		$level = 0;
#		$name = "";
#		$email = "";
#		$body = "";
#		$ltime = "";
#		$date = "";
#   }

	if ($r_in->{'az'} eq 'e_mesg') {
		$body = $r_in->{'body'};
	}
   elsif ($r_in->{'quote'}) {
		$body = format_quote($body);
   }
	else {
		$body = '';
	}


   #Let see if the user's logged on anyway...
   $html_output .= qq~
   <center>
   <form method="POST">
   <input type=hidden name="rand1" value="$r_in->{'rand1'}">
   <input type=hidden name="om" value="$r_in->{'om'}">
   <input type=hidden name="forum" value="$forum">
   <input type=hidden name="omm" value="$r_in->{'omm'}">
   ~;
  
   if ($r_in->{'az'} eq 'e_mesg') {
      $html_output .= qq~
         <input type=hidden name="az" value="$r_in->{'az'}">
      ~;
    }  
  

   $html_output .= qq~
   <TABLE CELLPADDING="3" cellspacing="2" BORDER="0" WIDTH="$table_width">
   <TR BGCOLOR="$bg_color_0">
   <TH ALIGN="LEFT" COLSPAN="2">
   <FONT SIZE="3" FACE="$font_face_0" COLOR="$font_color_0">
	Ihr Beitrag
   </FONT>
   </TH>
   </tr>
   <TR>
   <Td ALIGN="LEFT" valign="top" colspan="2">
   <FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
	~;

	if ($r_setup->{'board_setup'}->{'html_allowed'} eq 'on') {
		$html_output .= qq~
			<font color="#FF0000">
			HTML&nbsp;Tags&nbsp;sind erlaubt<br>
			</font>
			~;
	}
	if ($r_setup->{'board_setup'}->{'image_allowed'} eq 'on') {
		$html_output .= qq~
			<font color="#FF0000">
			Links&nbsp;zu&nbsp;Grafiken&nbsp;sind&nbsp;erlaubt<br>
			</font>
			~;
	}
	
	$html_output .= qq~
	</TD>
   </tr>
   <TR BGCOLOR="$bg_color_3">
   <TH ALIGN="RIGHT">
   <FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
   Name:
   </FONT>
   </TH>
   <TD>~;

   if ($r_in->{'userdata'}->{'Username'}) {
      $html_output .= qq~
      <input type="hidden" name="name" value="$r_in->{'userdata'}->{'Username'}">
      <FONT SIZE="2" FACE="$mesg_font" COLOR="$font_color_3">
      $r_in->{'userdata'}->{'Username'}
     </FONT>~;
   }
   else {
      $html_output .= qq~
      <INPUT TYPE="TEXT" NAME="name" SIZE=50>~;
   }

   $html_output .= qq~
   </TD></TR>
   <TR BGCOLOR="$bg_color_3">
   <TH ALIGN="RIGHT">
   <FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
   E-Mail:
   </FONT></TH>
   <TD BGCOLOR="$bg_color_3">~;

   if ($r_in->{'userdata'}->{'EMail'}) {
      $html_output .= qq~
      <input type="hidden" name="email" value="$r_in->{'userdata'}->{'EMail'}">
   	<FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
      $r_in->{'userdata'}->{'EMail'}
      </FONT>~;
   }
   else {
      $html_output .= qq~
          <INPUT TYPE="TEXT" NAME="email" SIZE=50>~;
   }

   $html_output .= qq~
      </TD></TR>
   <TR BGCOLOR="$bg_color_3">
   <TH ALIGN="RIGHT">
   <FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
   Thema:
   </FONT></TH>
   <TD BGCOLOR="$bg_color_3">~;

   if ($r_in->{'subject'} ne "") {
      $html_output .= qq~
	   <FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
      $r_in->{'subject'}
      </FONT>
      <INPUT TYPE="hidden" NAME="subject" VALUE="$r_in->{'subject'}" SIZE=50>~;
   }

# Sie k&ouml;nnen das auch von Email verwendete RE: Format f&uuml;r Antworten
# verwenden. Sie m&uuml;ssen dazu die folgenden Zeilen auskommentieren
###################################################################
#   elsif ($subject ne "") {
#      $html_output .= qq~
#      <INPUT TYPE="text" NAME="subject" VALUE="RE: $subject" SIZE=60>~;
#   }

   else {
      $html_output .= qq~
      <INPUT TYPE="TEXT" NAME="subject" VALUE="$r_in->{'subject'}" SIZE=50>
      ~;
   }

   $html_output .= qq~
   </TD>
   </TR>~;

   $html_output .= qq~
   <TR BGCOLOR="$bg_color_3">
   <TH ALIGN="RIGHT" VALIGN="TOP">
   <FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
   Text des Beitrags:
   </FONT>
   </TH>
   <TD>
   ~;

   if ($body) {
      $html_output .= qq~
      <TEXTAREA NAME="body" ROWS="15"
        COLS="50" WRAP="virtual">$body\n\n$r_profile->{'Signatur'}</TEXTAREA>
     ~;
   }
   else {
      $html_output .= qq~
      <TEXTAREA NAME="body" ROWS="12"
        COLS="50" WRAP="virtual">$r_profile->{'Signatur'}</TEXTAREA>
    ~;
   }
  
# $r_in->{'body'}\n\n

   $html_output .= qq~
   </TD></TR>~;

	if ($r_setup->{'board_setup'}->{'email_notification'} eq 'on') {		
			$html_output .= qq~
			<TR BGCOLOR="$bg_color_3">
   		<TH ALIGN="RIGHT" VALIGN="TOP">~;

		if ($r_in->{'email_notification'}) {
			$html_output .= qq~
   		<FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
				<input type="checkbox" name="email_notification" value='not_empty' checked>
	   		</FONT>~;
		}
		else {
			$html_output .= qq~
   		<FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
				<input type="checkbox" name="email_notification" value='not_empty'>
	   		</FONT>~;
		}
			$html_output .= qq~
   		</TH>
			<TH ALIGN="LEFT" VALIGN="TOP">
   		<FONT SIZE="$font_size_3" FACE="$font_face_3" COLOR="$font_color_3">
			 Markieren Sie die Checkbox wenn Sie bei Antworten eine Mail erhalten moechten.<p>
			</FONT>
			</TH>
			</tr>~;
	}

   $html_output .= qq~
   <TR><TH ALIGN="RIGHT" BGCOLOR="$bg_color_3">
   &nbsp;</TH>
   <TD BGCOLOR="$bg_color_3" ALIGN="LEFT">
   <INPUT TYPE="SUBMIT" NAME="preview_option" VALUE="Vorschau">
   <INPUT TYPE="SUBMIT" NAME="post_option" VALUE="Beitrag schreiben">
   <INPUT TYPE="RESET" VALUE="Eingaben l&ouml;schen">
   </TD></TR></TABLE>
   </form>
   </center>
  ~;

}

#####
#
# subroutine get_number
#
#####

sub get_number {

  	my ($datafile,$r_in) = @_;
  	my $num;

   open(NUMBER,"$datafile");
   flock(NUMBER,2);
      $num = <NUMBER>;
   flock(NUMBER,8);
   close(NUMBER);

   if ($num == 9999999 or $num eq "")  {
      $num = "1";
   }
   else {
      if ($r_in->{'om'} == 0) {
         $num++;
      }
   }

   open(NUM,">$datafile") || die $!;
   flock(NUMBER,2);
      print NUM "$num";
   flock(NUMBER,8);
   close(NUM);
   
   return $num;
}

#####
#
# subroutine edit
# allows the user to edit his/her message
#
#
#####

sub edit {

   my ($r_in,$r_setup) = @_;
	my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = 
		get_record("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",$r_in->{'omm'});

   # Now check and see if the message belongs to the rightful owner
   
   unless ($r_in->{'userdata'}->{'Username'} eq $name) {
      $html_output .= qq~
			<p>&nbsp;
			<center>
		   <FONT SIZE="4" FACE="$font_face_3" COLOR="$font_color_3">
         <b>FEHLER: Sie koennen diesen Eintrag nicht bearbeiten,<BR>dieser Beitrag ist nicht von Ihnen!</b>
   		</FONT>
			</center>
			<p>&nbsp;
			<p>&nbsp;
			<p>&nbsp;
      ~;
      return $html_output;
   }

   $body =~ s/<p>/\n\n/gi;
   $body =~ s/<br>/\r\n/gi;
   $body =~ s/<br>/\n/gi;
  	$body =~ s/<([^>]|\n)*>//g;

   $r_in->{'subject'} = $subject;
   $r_in->{'body'} = $body;
   $r_in->{'name'} = $name;
   $r_in->{'email'} = $email;
   $r_in->{'az'} = 'e_mesg';

   $in{'rand1'} = get_rand_lock();
   $html_output .= post($r_in,$r_setup);
   return $html_output;
}  


#####
#
# subroutine edit_message
# routine to edit message
#
#####

sub edit_message {

   my ($r_in,$r_setup) = @_; 
   my (@newrow);
   my $r_rowdata = readdata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext");
	my	$ltime = time_format($r_in->{'localtime'});
	my	$ldate = date_format($r_in->{'date'});

   my $temp = "<center><font size=\"1\" color=\"#ff0000\">Letzte Bearbeitung am $ldate um $ltime ($time_zone)</font></center><p>";

	$r_in->{'body'} = $temp . $r_in->{'body'};
	
	# First get the number of messages and the next message number
	$temp = shift @{$r_rowdata};

	# Write to @newrow, which will overright @$r_rowdata
   push(@newrow,"$temp");

	# At this point, $$r_in->{'omm'} is the message
	# Right before current thread
	# Now, just go thru the data again and thread it correctly

   foreach (@{$r_rowdata}) {
      chomp;
# BIG5
#		my @temp = split /::/;
		my @temp = split /\|/;
      if ($r_in->{'omm'} eq $temp[0]) {
			$temp[$#temp] = "$r_in->{'body'}";
# BIG5
#			my $temp_string = join("::",@temp);
			my $temp_string = join("\|",@temp);
         push(@newrow,"$temp_string\n");
	   }
		else {
		   push(@newrow,"$_\n");
		}
   }

	# Write to output file
   writedata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",\@newrow);

}

#####
# function get_rand_lock
#
#####

sub get_rand_lock {

	my $num;
   srand;
   $num = int(rand 1000000) + 1;
   open(DUMMYFILE,">$password_file_dir/$num.dat") or 
		my_die("FEHLER in der Randomfunktion, Passwort wurde nicht erstellt: $password_file_dir/$num.dat",$!);
   close(DUMMYFILE);

	return $num;

}

#####
# function check_rand_lock
#
#####

sub check_rand_lock {

	my $num = shift;
	if (-e "$password_file_dir/$num.dat") {
      unlink("$password_file_dir/$num.dat") or 
			my_die("FEHLER in der Randomfunktion, Passwort wurde nicht geloescht: $password_file_dir/$num.dat",$!);
		return 1;
   }
	else {
		return 0;
	}
}

####
#
# email notification
## Email notification extension
#$email_ext = "emn";
#$email_dir = "EMails";
####

sub email_notification {

	my ($r_in, $r_setup, $r_local) = @_;
	my $r_data = {};

	my $poster_email = remove_antispam($r_in->{'email'});
	
	if (-e "$maindir/$forum/$email_dir/$in{'om'}\.$email_ext") {
		$r_data = readdata("$maindir/$forum/$email_dir/$in{'om'}\.$email_ext");
	}

	my $num = @{$r_data};

	my $thread_subject = shift(@{$r_data});
	chomp($thread_subject);

	# generate mail message
	my $url;
	unless ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
		$url = "$mainurl/$forum/$in{'om'}\.$ext";
	}
	else {
		$url = "$exurl?az=show_thread&om=$in{'om'}&forum=$forum";					
	}

	my $mail .= qq~
Der Betreff des Beitrags ist: "$thread_subject".
Klicken Sie auf den folgenden Link um den Beitrag zu lesen.

$url
~;

	$email_notification_message =~ s/EMAIL_NOTIFICATION_MESSAGE/$mail/g;

	if ($num > 1) {

		my %seen = ();

		foreach (@{$r_data}) {
			chomp;
	  		$email = remove_antispam($_);
			push(@emails, $email) unless $seen{$email}++;
		}

		foreach (@emails) {
			unless ($_ eq $poster_email) {
		   	send_mail($password_file_dir, $r_local->{'Sendmail Path'},
      	   	$r_local->{'Admin EMail Address'},
         		$_,$email_notification_subject,$email_notification_message );
			}
		}

	}

}

###
# function check_email
#
###

sub check_email {

   my ($email) = shift;
    if ($email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/ || 
    
        ($email !~ /^.+\@localhost$/ && 
         $email !~ /^.+\@\[?(\w|[-.])+\.[a-zA-Z]{2,3}|[0-9]{1,3}\]?$/)) {

        return(0);
    }    
    else {
        return(1);
    }
}

#####
# filter_remote_posting
#
#####

sub filter_remote_posting {

	unless ( $ENV{'HTTP_REFERER'} =~ /$forumurl/) {

		my $temp = join("::",$r_in->{'userdata'}->{'Username'},
			$ENV{'REMOTE_HOST'},$ENV{'REMOTE_ADDR'});
	 	&check_datafile("$password_file_dir/$sec_file");
	 	appenddata("$password_file_dir/$sec_file",$temp);
	   print "Content-type: text/html\n";
   	print "\n";
		$heading = "FEHLER: Bitte kontakten Sie den Webmaster.<BR>Vielen Dank.";

		my %namespace = (
  	   	FORUMLINKS => $html_forum_links,
    	 	MENU => $menu_button,
     		TITLE => $heading,
     		HEADER => $heading,
     		SUBHEADER => $sub_heading,
     		HTMLOUTPUT => $html_output
		);

		display_output($templatefile,\%namespace);
		exit(0);			

	}

}