#!/usr/local/bin/perl
#
# dcuser.cgi
# DCForum99 Version 1.1
# Part of DCForum by DCScripts
# Copyright  1997-1999 DCScripts All Rights Reserved
# 
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum.
# You should carefully read this terms agreement as outlined in
# the readme.txt file included with this distribution before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
###################################################################
##  German translation by Lothar Jung for Webster Internet Dienstleistungen
##  http://Webster.de/dcscripts/
###################################################################

# Geben Sie den genauen Pfad ($path) zu diesem Programm an wenn
# wenn Sie bei der Ausf&uuml;hrung der Datei Probleme haben.
# Einige Server ben&ouml;tigen den vollen Pfad

$path = ".";

#>>>>>>>>>>>>>>> Keine weiteren &Auml;nderungen in diesem Script erforderlich <<<<<<<<

require "$path/dcforum.setup";
require "$path/dcadmin.setup";
require "$cgidir/cgi-lib.pl";
require "$cgidir/dclib.pl";
require "$cgidir/dcforumlib.pl";
require "$cgidir/dcforumlib2.pl";
require "$cgidir/dcprotect.pl";

$| = 1;

print "Content-type: text/html\n";

# Readin form date to %in
&ReadParse;
$r_in = \%in;

# Initialize setup variables and declear some global variables
$r_setup = initialize($password_file_dir,$forum_file,$board_setup_file);

require "$path/global.pl";

# User authentication
$r_in->{'userdata'} = {};
$session = get_cookie($cookie_name);
if ($session) {
	if (-e "$password_file_dir/$session.session") {
		$r_in->{'userdata'} = get_userdata("$password_file_dir/$session.session");
	}
	else {
	   send_cookie($cookie_name,'','Thur, 31-Dec-98 12:00:00 GMT','/');
		$session = '';
	}
}

# If no $session and forum_type if Private or Protected,
# well, then you need to have them logon
# However, if the request is only to view profile,
# then don't worry about it...

unless ($r_in->{'az'} eq 'show_profile') {
	unless ($session) {
	   $r_in->{'userdata'} = dcprotect($dcuser,$password_file_dir,$r_in,
	      \@login_fields,\%field_form_type);
	}
	else {
		$r_in->{'email'} = add_antispam($r_in->{'email'});
	}
}


# Get some login information
# datadir needed by dcprotect.pl
# It's where password file is...

$r_in->{'datadir'} = $password_file_dir;
$r_local = init($dcuser,$password_file_dir,$r_in,\@login_fields,\%form_type);

$menu_button = create_button("user_menu",$r_in,$r_setup);

print "\n";	#End of HTTP Header

# Make sure no remote posting

unless ($ENV{'HTTP_REFERER'} =~ /$forumurl/) {

	($heading,$sub_heading,$html_output) = 
	access_error('remote posting',$r_in,$r_setup);
}
elsif ($r_in->{'az'} eq 'show_profile') {

	$heading = "Benutzerprofil von $r_in->{'user'}";
	$sub_heading = "";
	$html_output = show_profile($r_in,$r_local);
	unless ($html_output) {
		$sub_heading = "<b><font size=3>Kein Profil angelegt</font></b>";
		$html_output = "";
	}

}
elsif ($r_in->{'az'} eq 'change_password') {

	($heading,$sub_heading,$html_output) = change_password($r_in,$r_local);

}
elsif ($r_in->{'az'} eq 'change_profile') {

	($heading,$sub_heading,$html_output) = change_profile($r_in,$r_local);
}
elsif ($r_in->{'az'} eq 'change_account_info') {

	($heading,$sub_heading,$html_output) = change_account_info($r_in,$r_local,$r_setup);
}
else {

   $heading = "DCForum User Men&uuml;";
   $sub_heading = "W&auml;hlen Sie eine der folgenden Funktionen";
	$html_output = main_form($r_in,$r_local);

}

my %namespace = (
     FORUMLINKS => $html_forum_links,
     MENU => $menu_button,
     TITLE => $heading,
     HEADER => $heading,
     SUBHEADER => $sub_heading,
     HTMLOUTPUT => $html_output
);

display_output($templatefile,\%namespace);

exit(0);

#####
# function main_form
#
#####

sub main_form {

   my ($r_in,$r_local) = @_;

	my $html_output .= qq~
   <form method="post">
   <table border="0" width="$table_width" cellspacing="2" cellpadding="3">
	<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
		&nbsp;</font></TH></TR>~;

	if ($r_local->{'auth'}->{'Allow Users to Change Password'} eq 'on') {
		$html_output .= qq~
		<TR BGCOLOR="$bg_color_3"><td ALIGN="Right">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
	       <input type="radio" name="az" value="change_password"></font></td>
			<TH ALIGN="LEFT">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			Passwort &auml;ndern</font></TH></TR>~;
	}
	if ($r_local->{'auth'}->{'Allow Users to Modify Account Infomation'} eq 'on') {
		$html_output .= qq~
		<TR BGCOLOR="$bg_color_3"><td ALIGN="Right">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
	       <input type="radio" name="az" value="change_account_info"></font></td>
			<TH ALIGN="LEFT">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			&Auml;ndern Ihrer Userdaten</font></TH></TR>~;
	}

	$html_output .= qq~	
	<TR BGCOLOR="$bg_color_3"><td ALIGN="Right">
		<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
       <input type="radio" name="az" value="change_profile"></font></td>
		<TH ALIGN="LEFT">
		<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
		&Auml;ndern Ihres Benutzerprofil</font></TH></TR>
	<TR BGCOLOR="$bg_color_3">
     <td align="left">&nbsp;</td>
     <td align="left">
     <input type="submit" value="absenden">
     <input type="reset" value="l&ouml;schen"></td></tr>
		<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
			&nbsp;</font></TH></TR>
   </table>
   </form>~;

	$html_output;

}
#####
#
# function change_account_info
#
#####

sub change_account_info {

   my ($r_in,$r_local,$r_setup) = @_;

	my $heading = "DCForum User Men&uuml;";

   if ($r_in->{'command'} eq 'save') {

		get_login_data("$r_in->{'password_file_dir'}/$r_in->{'password_file'}",
			$r_in->{'userdata'}->{'Username'},$r_local);

     	foreach (@{$r_local->{'fields'}}) {
			unless ($r_in->{$_}) {
         	$r_in->{$_} = $r_local->{'login_info'}->{$_};
			}
      }

		# Following three lines are required for using update_user
	   $r_in->{'dup_Password'} = $r_in->{'Password'};
		$r_in->{'no_crypt'} = 'YES';
		$r_in->{'Username'} = $r_in->{'userdata'}->{'Username'};

      $error = update_user($r_in,$r_local);

		# Next we must update the sessions file

		my @temp_array;
      unless($error) {
     		foreach (@{$r_local->{'fields'}}) {
				unless ($_ eq "Password") {
					my $temp_string = join ("::",$_,$r_in->{$_});
        			push(@temp_array,"$temp_string\n");
				}
      	}

			my $access = "Forums::";
   		foreach $forum (@{$r_setup->{'forums'}}) {
				if ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
					if (-e "$password_file_dir/$forum.$priv_user_ext") {
						$r_members = readdata("$password_file_dir/$forum.$priv_user_ext");
					}
					foreach (@{$r_members}) {
						chomp;
						if ($r_in->{'Username'} eq $_) {
							$access .= "$forum,";
							last;
						}
					}
				}
			} # End of $forum..etc

			chop($access) if ($access =~ /\,$/);
        	push(@temp_array,"$access\n");
			
			# Create session file
			writedata_nolock("$r_in->{'password_file_dir'}/$session.session",\@temp_array);

			
#			else {
#			   send_cookie($cookie_name,$session,'Thur, 31-Dec-98 12:00:00 GMT','/');
#				$session = '';
#			}

         $sub_heading = qq~
			<b>
			Ihre Userdaten wurden aktualisiert.</b><br>~;
			
			$html_output = main_form($r_in,$r_local);
      }
      else {
         $sub_heading = "<b><font size=3>ERROR: Account modification error<br>
				Ihre Userdaten wurden nicht ge&auml;ndert!!! 
				<p> Grund: $error</font></b>\n";
	      $html_output .= change_account_form($r_in);
      }

   }
   else {
      $sub_heading = "<b>&Auml;ndern Ihrer Userdaten</b>";
      $html_output .= change_account_form($r_in);
   }

	return ($heading,$sub_heading,$html_output);

}



####
# function change_account_form
# form for changing user account information
####

sub change_account_form {

	my $r_in = shift;

	my $html_output;
	
	# read data into $r_local->{'login_info'}
	
	get_login_data("$r_in->{'password_file_dir'}/$r_in->{'password_file'}",
			$r_in->{'userdata'}->{'Username'},$r_local);


	my $output .= qq~
      <form method="post">
      <input type="hidden" name="az" value="$r_in->{'az'}">
      <input type="hidden" name="command" value="save">
      <table border="0" width="$table_width">
		<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
			&nbsp;</font></TH></TR>
	~;

   foreach (keys %{$r_local->{'login_info'}} ) {
		unless ($_ eq 'Username' or $_ eq 'Password' 
			or $_ eq 'Group' or $_ eq 'Status') {
			if ($_ eq "EMail") {
				my $temp = remove_antispam($r_local->{'login_info'}->{$_});
					$output .= qq~
					<TR BGCOLOR="$bg_color_3">
						<TH ALIGN="Right">
						<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
						$_</font></TH><td ALIGN="LEFT">
						<input type="text" size="40" name="$_" value="$temp">
						~;
			}
			else {
				my $temp = $r_local->{'login_info'}->{$_};
					$output .= qq~
					<TR BGCOLOR="$bg_color_3">
						<TH ALIGN="Right">
						<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
						$_</font></TH><td ALIGN="LEFT">
						<input type="text" size="40" name="$_" value="$temp">
						~;
			}
		}
    }

	
  $output .= qq~
	 	</td></tr>
        <tr>
        <th>&nbsp;</th>
        <td>
          <input type="submit" value="Registrierung abschicken">
          <input type="reset" value="l&ouml;schen">
        </td>
        </tr>
  </table>
  </form>
	~;

	return $output;
}

#####
#
# function change_password
# Whatelse?  Changes user password
#
#####

sub change_password {

   my ($r_in,$r_local) = @_;

	my $heading = "DCForum User Men&uuml;";

   if ($r_in->{'command'} eq 'save') {

		get_login_data("$r_in->{'password_file_dir'}/$r_in->{'password_file'}",
			$r_in->{'userdata'}->{'Username'},$r_local);

      my $test = my_crypt ($r_in->{'Old_Password'},$r_local->{'login_info'}->{'Password'});

      unless ($test eq $r_local->{'login_info'}->{'Password'}) {
         my $heading = "FEHLER: Passwort&auml;nderung fehlgeschlagen";
         my $sub_heading = "<b><font size=3>Das Passwort wurde nicht ge&auml;ndert!!! 
				<p> Grund: Sie haben ein falsches Passwort eingetragen.</font></b>\n";
	      $html_output .= change_password_form($r_in);
         return ($heading,$sub_heading,$html_output);
      }

      $r_in->{'Password'} = $r_in->{'New_Password'};
     	$r_in->{'dup_Password'} = $r_in->{'dup_New_Password'};

     	foreach (@{$r_local->{'fields'}}) {
         unless($_ eq 'Password') {
         	$r_in->{$_} = $r_local->{'login_info'}->{$_};
       	}
      }

		$r_in->{'Username'} = $r_in->{'userdata'}->{'Username'};

      $error = update_user($r_in,$r_local);

      unless($error) {

			if (-e "$r_in->{'password_file_dir'}/$session.session") {
				unlink("$r_in->{'password_file_dir'}/$session.session");
			}
			else {
			   send_cookie($cookie_name,$session,'Thur, 31-Dec-98 12:00:00 GMT','/');
				$session = '';
			}

         $heading = "DCForum Login";
         $sub_heading = "Ihr Passwort wurde ge&auml;ndert.<br>\n";
         $sub_heading .= qq~
           Bitte merken Sie sich Ihr neues Passwort gut<BR>und geben Sie es nicht an dritte weiter!<br>
			  Sie m&uuml;ssen sich nun neu einloggen.~;

			 # Send Email to user...

			if ($r_local->{'auth'}->{'Notify User on Act/Deactivation'} eq 'on') {
	          my $subject = "DCForum User Account Activity Information";
	          my $mail_message = "Passwortaenderung erolgreich.\n";
	          $mail_message .= "Ihr Username: $r_in->{'userdata'}->{'Username'}\n";
	          $mail_message .= "Ihr neues Passwort: $r_in->{'New_Password'}\n";
	          $mail_message .= "Bitte merken Sie sich Ihr neues Passwort gut\n";
			  $mail_message .= "und geben Sie es nicht an dritte weiter!\n";
				
	          send_mail($datadir, $r_local->{'auth'}->{'Sendmail Path'},
	            $r_local->{'auth'}->{'Admin EMail Address'},
	            $r_in->{'EMail'},$subject,$mail_message );
			}
			
			$r_in->{'az'} = '';
         $html_output .= display_logon($r_in,$r_local);

      }
      else {
         $sub_heading = "<b><font size=3>FEHLER: Password&auml;nderung fehlgeschlagen<br>
					Das Passwort wurde nicht ge&auml;ndert!!! 
				<p> Grund: $error</font></b>\n";
	      $html_output .= change_password_form($r_in);
      }

   }
   else {
      $sub_heading = "Passwort &auml;ndern";
      $html_output .= change_password_form($r_in);
   }

	return ($heading,$sub_heading,$html_output);

}



####
# function change_password_form
# form for changing user password
####

sub change_password_form {

	my $r_in = shift;

	my $output .= qq~
      <form method="post">
      <input type="hidden" name="az" value="$r_in->{'az'}">
      <input type="hidden" name="command" value="save">
      <table border="0" width="$table_width">
		<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
			&nbsp;</font></TH></TR>
		<TR BGCOLOR="$bg_color_3">
			<TH ALIGN="Right">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			Altes Passwort</font></TH>
			<td ALIGN="LEFT">
				<input type="password" name="Old_Password" size="40"></td>
		</TR>
		<TR BGCOLOR="$bg_color_3">
			<TH ALIGN="Right">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			Neues Passwort
			</font></TH>
			<td ALIGN="LEFT">
				<input type="password" name="New_Password" size="40"></td>
		</TR>
		<TR BGCOLOR="$bg_color_3">
			<TH ALIGN="Right">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			Neues Passwort zur Kontrolle
			</font></TH>
			<td ALIGN="LEFT">
				<input type="password" name="dup_New_Password" size="40"></td>
		</TR>
		<TR BGCOLOR="$bg_color_3">
     	<td align="left">&nbsp;</td>
     	<td align="left">
     	<input type="submit" value="absenden">
     	<input type="reset" value="l&ouml;schen"></td></tr>
		<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
			&nbsp;</font></TH></TR>
		</table></form>
     ~;

}



#####
#
# function change_profile
# Whatelse?  Changes user profile
#
#####

sub change_profile {

   my ($r_in,$r_local) = @_;
	my $html_output;

   my $heading = "DCForum User Profil Manager";

   if ($r_in->{'command'} eq 'save') {

		# Profiles directory and extension

		$html_output = main_form($r_in,$r_local);
	
		$html_output .= qq~
	      <table border="0" width="$table_width">
			<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
				&nbsp;</font></TH></TR>
		~;
	
		# Get user information
		my $dir = "$r_in->{'password_file_dir'}/$profile_dir";
		my $ext = $profile_ext;

		foreach $_ (@profile_fields) {
			$r_in->{$_} =~ s/\n\n/<p>/ig;
			$r_in->{$_} =~ s/\r\n/<br>/ig;
			$r_in->{$_} =~ s/\n/<br>/ig;
			unless ($_ eq 'Password' or $_ eq 'Username' 
					or $_ eq 'Group' or $_ eq 'Status' ) {
				my $line = join("::",$_,$r_in->{$_});
				push(@lines,"$line\n");
				$html_output .= qq~
				<TR BGCOLOR="$bg_color_3">
					<TH ALIGN="Right" VALIGN="TOP">
					<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
					$_</font></TH>
					<td ALIGN="LEFT"><font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
					$r_in->{$_}</font>&nbsp;
					</td></tr>~;
			}
		}
		  $html_output .= qq~
				<TR BGCOLOR="$bg_color_0">
					<TH ALIGN="Right" VALIGN="TOP">&nbsp;</TH>
					<td ALIGN="LEFT"><font SIZE="2" FACE="$font_face_0" color="$font_color_0">
					<b>[ <a href="$ENV{'HTTP_REFERER'}">Zur&uuml;ck zur vorigen Seite</a> ]</b>
					</font>
					</td></tr>
		  </table>
		~;

		writedata_nolock("$dir/$r_in->{'userdata'}->{'Username'}.$ext",\@lines);
      $sub_heading = "<b>Ihr Userprofil wurde ge&auml;nder.</b>";

   }
   else {
      $sub_heading = "&Auml;ndern Ihres Userprofils";
      $html_output .= change_profile_form($r_in);
   }

	return ($heading,$sub_heading,$html_output);

}


sub change_profile_form {

	my $r_in = shift;

	# Get user information
	my $dir = "$r_in->{'password_file_dir'}/$profile_dir";
	my $ext = $profile_ext;

	unless (-e "$dir/$r_in->{'userdata'}->{'Username'}.$ext") {
		foreach (keys %{$r_in->{'userdata'}}) {
			unless ($_ eq 'Password' or $_ eq 'Username' 
					or $_ eq 'Group' or $_ eq 'Status' ) {
				my $line = join("::",$_,$r_in->{'userdata'}->{$_});
				push(@lines,"$line\n");
			}
		}
		writedata_nolock("$dir/$r_in->{'userdata'}->{'Username'}.$ext",\@lines);
	}

	$r_in->{'userdata'} = get_userdata("$dir/$r_in->{'userdata'}->{'Username'}.$ext");
	my $output .= qq~
      <form method="post">
      <input type="hidden" name="az" value="$r_in->{'az'}">
      <input type="hidden" name="command" value="save">
      <table border="0" width="$table_width">
		<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
			&nbsp;</font></TH></TR>
	~;
	
	foreach $profile_field (@profile_fields) {

		$r_in->{'userdata'}->{$profile_field} =~ s/<p>/\n\n/ig;
		$r_in->{'userdata'}->{$profile_field} =~ s/<br>/\n/ig;
		
		$output .= qq~
		<TR BGCOLOR="$bg_color_3">
			<TH ALIGN="Right" Valign="top">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			$profile_field</font></TH>
			<td ALIGN="LEFT">~;

# BIG5
#	   my @fields = split(/::/,$profile_form_type{$profile_field});
	   my @fields = split(/\|/,$profile_form_type{$profile_field});
    	my $required = pop(@fields);

      if ($required eq "required") {
         if (defined $temp{'required'}) {
            $temp{'required'} = join("\,",$temp{'required'},$field);
         }
    	   else {
            $temp{'required'} = $field;
         }
		}
      else {
          push(@fields,$required);
          $suffix = ":";
      }

      if ($fields[0] eq "text") {
          $output .= qq~
           <input type="$fields[0]" name="$profile_field"
            size="$fields[1]" value="$r_in->{'userdata'}->{$profile_field}">
      	~;
		}
      elsif ($fields[0] eq "hidden") {
         $output .= qq~
          <input type="$fields[0]" name="$profile_field" value="$fields[1]">
        ~;
      }
      elsif ($fields[0] eq "radio" || $fields[0] eq "checkbox") {

	      $output .= qq~
	        $field$suffix
	        ~;
	      my $type = $fields[0];
	      shift(@fields);
      	foreach (@fields) {
        		if ($_ eq $r_in->{'userdata'}->{$profile_field}) {
          		$output .= qq~
          		<input type="$type" name="$profile_field" value="$_" checked>$_
          		~;
        		}
        		else {
          		$output .= qq~
          		<input type="$type" name="$profile_field" value="$_" >$_
          		~;
       		}
      	}

		}
    elsif ($fields[0] eq "textarea") {
      $output .= qq~
          <textarea name="$profile_field" rows="$fields[1]" 
          cols="$fields[2]" wrap="physical">$r_in->{'userdata'}->{$profile_field}</textarea>
      ~;
    }

  }

  $output .= qq~
	 	</td></tr>
        <tr>
        <th>&nbsp;
        <input type="hidden" name="required" value="$temp{'required'}"></th>
        <td>
          <input type="submit" value="Registrierung abschicken">
          <input type="reset" value="l&ouml;schen">
        </td>
        </tr>
  </table>
  </form>
~;

}

####
# function show_profile
# display user profile
# Note - the person who check the profile
# doesn't have to be logged on
####
sub show_profile {

	my $r_in = shift;

	# Get user information
	my $dir = "$r_in->{'password_file_dir'}/$profile_dir";
	my $ext = $profile_ext;

	if (-e "$dir/$r_in->{'user'}.$ext") {
		$r_in->{'userdata'} = get_userdata("$dir/$r_in->{'user'}.$ext");
	}
	else {
		return 0;
	}

	my $output .= qq~
      <table border="0" width="$table_width">
		<TR BGCOLOR="$bg_color_0"><td ALIGN="Right" colspan="2">
			&nbsp;</font></TH></TR>
	~;
	
	foreach $profile_field (@profile_fields) {		
		$output .= qq~
		<TR BGCOLOR="$bg_color_3">
			<TH ALIGN="Right" VALIGN="TOP">
			<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			$profile_field</font></TH>
			<td ALIGN="LEFT"><font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
			$r_in->{'userdata'}->{$profile_field}</font>&nbsp;
			</td></tr>~;
	}
		
  $output .= qq~
		<TR BGCOLOR="$bg_color_0">
			<TH ALIGN="Right" VALIGN="TOP">&nbsp;</TH>
			<td ALIGN="LEFT"><font SIZE="2" FACE="$font_face_0" color="$font_color_0">
			<b>[ <a href="$ENV{'HTTP_REFERER'}">Zur&uuml;ck zur vorigen Seite</a> ]</b>
			</font>
			</td></tr>
  </table>
~;

}

